unit TabSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GenericTableSet, Menus, StdCtrls, ExtCtrls, DBTables, TableUtils,
  ComCtrls;

type
  TTableSetForm = class(TGenericTableSetForm)
    EmptyAllTables1: TMenuItem;
    procedure EmptyAllTables1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    procedure  SetAlias(const Alias: string); override;
    function   GetAlias: string; override;
    function   GetDataModule: TDataModule; override;
  public
    { Public declarations }
    procedure EmptyTable(Table: TTable);
    procedure  TableStatus(Sender: TObject; const Msg: string; LastOperation: boolean); override;
  end;

var
  TableSetForm: TTableSetForm;

implementation

uses Pool_Mod_Unit;

{$R *.DFM}

procedure TTableSetForm.EmptyAllTables1Click(Sender: TObject);
begin
   ForEachTableIn(Pool_Module, EmptyTable);
end;

procedure TTableSetForm.EmptyTable(Table: TTable);
begin
   Table.Active := False;
   Table.Exclusive := True;
   Table.EmptyTable;
   Table.Active := True;
end;

procedure TTableSetForm.TableStatus(Sender: TObject; const Msg: string; LastOperation: boolean);
begin
   inherited;
   dw.StatPanel1.Caption := Msg;
end;

function TTableSetForm.GetAlias: string;
begin
   Result := POOL_ALIAS
end;

function TTableSetForm.GetDataModule: TDataModule;
begin
   Result := Pool_Module;
end;

procedure TTableSetForm.SetAlias(const Alias: string);
begin
   // Do Nothing
end;

procedure TTableSetForm.FormCreate(Sender: TObject);
begin
   inherited;
   MainTable := 'Games';
   SetDefaultExtension('Pool Database', 'pdb');
end;

end.
