unit Data;

interface

uses
  Classes, SysUtils, WinSock, Windows, Messages, Forms, Graphics, JPEG;

type
   TDataThread = class(TThread)
   protected
      ShowAll     : boolean;
      procedure   Execute; override;
      procedure   GetCommands;
      procedure   ShowProcesses;
      procedure   KillProcess(pid: integer);
      procedure   ScreenCap(const BmpName: string);
   public
      DataSock    : TSocket;
      RemoteHost  : string;
   end;

implementation

uses SockUtil;

{ TDataThread }

const
   CR = #13#10;

procedure TDataThread.Execute;
var
   pw : string;
begin
   Priority := tpHighest;

   try
      PutLine(DataSock, 'Remote Admin');
      PutLine(DataSock, 'Enter Password:');
      pw := GetLineCR(DataSock, True, True);
      Sleep(100);
      if pw<>'adminman' then raise Exception.Create('Bad Password');

      GetCommands;
   except
   end;
   closesocket(DataSock);
end;

procedure TDataThread.GetCommands;
label
   Parse;
var
   s     : string;
   arg   : string;
   i     : integer;
   sl    : TStringList;
   cwrc  : integer;
   p     : integer;
   tmp   : string;
   buf   : array[0..MAX_PATH] of char;
   path  : string;
   sr    : TSearchRec;
   dt    : TDateTime;
   ft    : TFileTime;
   st    : TSystemTime;
   pid   : integer;
   wh    : integer;
   StartInfo   : TStartupInfo;
   ProcInfo    : TProcessInformation;
begin
   repeat
      PutLine(DataSock, '');
      PutLine(DataSock, 'Enter Command:   (' + FormatDateTime('mmm dd hh:nn:ss ampm', Now)+')');
      s := GetLineCR(DataSock, True, False);

Parse:
      p := Pos(' ', s);
      Arg := '';
      if p<>0 then begin
         Arg := Copy(s, p+1, Length(s));
         s := UpperCase(Copy(s, 1, p-1));
      end else begin
         s := UpperCase(s);
      end;

      if s='EXIT' then exit;

      if (s='HELP') or (s='?') then begin
         PutLine(DataSock, 'EXIT, HELP, PWD, CD, DIR, PS, PSALL, COM');
         PutLine(DataSock, 'TYPE, KILL, CLOSEWIN, START, SCREENCAP, MAXWIN');
         continue;
      end;

      if s = 'COM' then begin
         s := 'START C:\COMMAND.COM /c ' + Arg;
         goto Parse;
      end;

      if s = 'START' then begin
         GetStartupInfo(StartInfo);

         try
            Win32Check(CreateProcess(nil, PChar(Arg), nil, nil, False, 0,
               nil, nil, StartInfo, ProcInfo));
            PutLine(DataSock, 'Started: ' + Arg)
         except
            on e:Exception do begin
               PutLine(DataSock, 'Start Failed: ' + Arg);
               PutLine(DataSock, e.Message);
               end;
         end;
         continue;
      end;

      if s = 'TYPE' then begin
         sl := TStringList.Create;
         try
            sl.LoadFromFile(Arg);
            for i := 0 to sl.Count-1 do
               PutLine(DataSock, sl[i]);
         except
            sl.Free;
         end;
         continue;
      end;

      if s = 'KILL' then begin
         try
            pid := StrToInt('$'+Arg);
         except
            pid := -1;
         end;
         if pid<>-1 then KillProcess(pid);
         continue;
      end;

      if s = 'CLOSEWIN' then begin
         try
            wh := StrToInt('$'+Arg);
         except
            wh := -1;
         end;
         if wh<>-1 then begin
            cwrc := SendMessage(wh, WM_CLOSE, 0, 0);
            PutLine(DataSock, 'CloseWin Result = ' + IntToStr(cwrc));
         end;
         continue;
      end;

      if s = 'MAXWIN' then begin
         try
            wh := StrToInt('$'+Arg);
         except
            wh := -1;
         end;
         if wh<>-1 then begin
            ShowWindow(wh, SW_RESTORE);
            PutLine(DataSock, 'MAXWIN done');
         end;
         continue;
      end;

      if s='PS' then begin
         ShowAll := False;
         ShowProcesses;
         continue;
      end;

      if s='PSALL' then begin
         ShowAll := True;
         ShowProcesses;
         continue;
      end;

      if s = 'CD' then begin
         StrPCopy(buf, Arg);
         SetCurrentDirectory(buf);

         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);
         continue;
      end;

      if s='PWD' then begin
         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);
         continue;
      end;

      if s = 'DIR' then begin
         tmp := Arg;
         if tmp='' then tmp := '*.*';

         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);

         path := buf;
         if Copy(path, Length(path), 1)<>'\' then path := path + '\';
         if FindFirst(path+tmp, faAnyFile, sr)=0 then repeat
            tmp := sr.Name;
            if (sr.Attr and faDirectory)<>0 then tmp := tmp + '\';
            ft := sr.FindData.ftLastWriteTime;
            FileTimeToLocalFileTime(ft, ft);
            FileTimeToSystemTime(ft, st);
            dt := SystemTimeToDateTime(st);
            s := Format('%10.0n   %s   %s', [sr.Size+0.0, FormatDateTime('mm/dd/yy hh:nn:ss', dt), tmp]);
            PutLine(DataSock, s);
         until FindNext(sr)<>0;
         continue;
      end;

      if s = 'SCREENCAP' then begin
         ScreenCap('C:\SCREEN.BMP');
         continue;
      end;

      PutLine(DataSock, 'Unknown Command: ' + s);

   until False;
end;

function EnumWinProc(Handle: THandle; LParam: integer): boolean; stdcall;
var
   dt  : TDataThread;
   buf : array[0..MAX_PATH] of char;
   pid : integer;
   hp  : THandle;
   pc  : integer;
   s   : string;
begin
   Result := True;
   dt := TDataThread(LParam);
   GetWindowText(Handle, buf, sizeof(buf));

   if Length(buf)=0 then exit;

   if (not IsWindowVisible(Handle)) and (not dt.ShowAll) then exit;

   GetWindowThreadProcessId(Handle, @pid);

   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   pc := GetPriorityClass(hp);
   CloseHandle(hp);

   s := Format('%8.8x  %3d  %4.4x  %-40s', [Handle, pc, pid, buf, pid]);
   PutLine(dt.DataSock, s);
end;

procedure TDataThread.ShowProcesses;
var
   s : string;
begin
   s := Format('%-8s  %-3s  %-8s  %-40s', ['WinHan', 'PRI', 'PID', 'APP NAME']);
   PutLine(DataSock, s);
   EnumWindows(@EnumWinProc, integer(Self));
end;

procedure TDataThread.KillProcess(pid: integer);
var
   hp : THandle;
begin
   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   if TerminateProcess(hp, -1) then begin
      PutLine(DataSock, 'Process Terminated');
   end else begin
      PutLine(DataSock, 'Unable to Terminate Process!');
   end;
   CloseHandle(hp);
end;


procedure TDataThread.ScreenCap(const BmpName: string);
var
   bm    : TBitmap;
   jp    : TJpegImage;
   jf    : string;
   c     : TCanvas;
   dc    : HDC;
   R     : TRect;
begin
   PutLine(DataSock, 'Performing Screen Capture');

   bm := TBitmap.Create;
   dc := GetDC(0);
   try
      bm.Width  := Screen.Width;
      bm.Height := Screen.Height;

      c := TCanvas.Create;
      c.Handle  := dc;

      R := Rect(0, 0, Screen.Width, Screen.Height);
      bm.Canvas.CopyRect(R, c, R);
      bm.HandleType := bmDIB;
      bm.SaveToFile(BMPNAME);
      PutLine(DataSock, 'Wrote to file: ' + BMPNAME);

      // Now save it as a JPEG too
      jp := TJpegImage.Create;
      jp.CompressionQuality := 50;
      jp.Assign(bm);
      jf := ChangeFileExt(BmpName, '.JPG');
      jp.SaveToFile(jf);
      PutLine(DataSock, 'Wrote to file: ' + jf);
      jp.Free;

      c.Free;
   finally
      ReleaseDC(0, dc);
      bm.Free;
   end;
end;



end.
